//*****************************************************************************
//
//	Kommandointerpreter0 fuer UART0
//
//*****************************************************************************
#include <avr/io.h>
#include <avr/interrupt.h>
#include <stdint.h>
#include <avr/wdt.h> 
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "watchdog.h"
#include "kommand0.h"
#include "proto0.h"


char c_txstr0[80];


//*****************************************************************************
//	Kommand - Kommandointerpreter
//  Input:	Befehlsstring
//	Output:	-
//*****************************************************************************
void Kommandointerpreter0(char * pc_str)
{
unsigned char uc_ok = 0;

   watchdog_reset();
   if (strncmp(pc_str,"OK",2) == 0)       uc_ok = BEFEHL0_OK(pc_str+2); 
   watchdog_reset();

   if (!uc_ok) BEFEHL0_ERROR("");
}


//*****************************************************************************
//	Kommand - Kommando OK  
//  Input:	-
//	Output:	-
//*****************************************************************************
unsigned char BEFEHL0_OK(char * pc_str)
{
   watchdog_reset();	
   strcpy(c_txstr0,"OK");
   sende_UART0(c_txstr0);
   return(1);
}


//*****************************************************************************
//	Kommand - Kommando ERROR  
//  Input:	-
//	Output:	-
//*****************************************************************************
unsigned char BEFEHL0_ERROR(char * pc_str)
{
   watchdog_reset();
   strcpy(c_txstr0,"ERROR");
   sende_UART0(c_txstr0);
   return(1);
}







