//*****************************************************************************
//
//	Protokoll fuer UART1
//
//*****************************************************************************
#include <avr/io.h>
#include <stdint.h>
#include <avr/wdt.h>
#include <avr/interrupt.h>
#include "uart1.h"
#include "proto1.h"
#include "kommand1.h"
#include <string.h>
#include <stdlib.h>
#include "watchdog.h"

#define STARTKENNUNG1 0x24
#define ENDEKENNUNG1  0x0d
#define START1        0x01
#define ENDE1         0x00


char c_str1[80];
unsigned char uc_zeichen1,uc_uartstatus1 = 0;


//*****************************************************************************
//	Protokoll - Zeichenauswertung der UART1
//  Input:	-
//	Output:	-
//*****************************************************************************
void receive_uart1(void)
{
unsigned char uc_x;

  uc_x = UART1_RX();

  watchdog_reset();
 
  if (uc_uartstatus1 == START1)
   {
     c_str1[uc_zeichen1] = uc_x;
	 uc_zeichen1++;
   }
  
  if (uc_x == STARTKENNUNG1)
   {
      uc_uartstatus1 = START1;
	  uc_zeichen1 = 0;
   }	  

  watchdog_reset();

  if ((uc_uartstatus1 == START1) && (uc_x == ENDEKENNUNG1)) 
   {
      uc_uartstatus1 = ENDE1;
	  if (uc_zeichen1 > 0) uc_zeichen1--;
	  c_str1[uc_zeichen1] = '\0';
	  Kommandointerpreter1(c_str1);
   }	    

  watchdog_reset();
}


//*****************************************************************************
//	Protokoll - String ueber UART0 an PC senden
//  Input:	-
//	Output:	-
//*****************************************************************************
void sende_UART1(char * pc_str)
{
char c_start[2] = {STARTKENNUNG1,0x00};
char c_ende[2]  = {ENDEKENNUNG1,0x00};

   watchdog_reset();
   strcpy(c_str1,c_start);
   strcat(c_str1,pc_str);
   watchdog_reset();
   strcat(c_str1,c_ende);
   watchdog_reset();

   UART1_TXStr(c_str1);
   strcpy(c_str1,""); 
   watchdog_reset();
}


