//*****************************************************************************
//
//	Protokoll fuer UART2
//
//*****************************************************************************
#include <avr/io.h>
#include <stdint.h>
#include <avr/wdt.h>
#include <avr/interrupt.h>
#include "uart2.h"
#include "proto2.h"
#include "kommand2.h"
#include <string.h>
#include <stdlib.h>
#include "watchdog.h"

#define STARTKENNUNG2 0x24
#define ENDEKENNUNG2  0x0d
#define START2        0x02
#define ENDE2         0x00


char c_str2[80];
unsigned char uc_zeichen2,uc_uartstatus2 = 0;


//*****************************************************************************
//	Protokoll - Zeichenauswertung der UART2
//  Input:	-
//	Output:	-
//*****************************************************************************
void receive_uart2(void)
{
unsigned char uc_x;

  uc_x = UART2_RX();

  watchdog_reset();
 
  if (uc_uartstatus2 == START2)
   {
     c_str2[uc_zeichen2] = uc_x;
	 uc_zeichen2++;
   }
  
  if (uc_x == STARTKENNUNG2)
   {
      uc_uartstatus2 = START2;
	  uc_zeichen2 = 0;
   }	  

  watchdog_reset();

  if ((uc_uartstatus2 == START2) && (uc_x == ENDEKENNUNG2)) 
   {
      uc_uartstatus2 = ENDE2;
	  if (uc_zeichen2 > 0) uc_zeichen2--;
	  c_str2[uc_zeichen2] = '\0';
	  Kommandointerpreter2(c_str2);
   }	    

  watchdog_reset();
}


//*****************************************************************************
//	Protokoll - String ueber UART0 an PC senden
//  Input:	-
//	Output:	-
//*****************************************************************************
void sende_UART2(char * pc_str)
{
char c_start[2] = {STARTKENNUNG2,0x00};
char c_ende[2]  = {ENDEKENNUNG2,0x00};

   watchdog_reset();
   strcpy(c_str2,c_start);
   strcat(c_str2,pc_str);
   watchdog_reset();
   strcat(c_str2,c_ende);
   watchdog_reset();

   UART2_TXStr(c_str2);
   strcpy(c_str2,""); 
   watchdog_reset();
}


