//*****************************************************************************
//
//	Protokoll fuer UART3
//
//*****************************************************************************
#include <avr/io.h>
#include <stdint.h>
#include <avr/wdt.h>
#include <avr/interrupt.h>
#include "uart3.h"
#include "proto3.h"
#include "kommand3.h"
#include <string.h>
#include <stdlib.h>
#include "watchdog.h"

#define STARTKENNUNG3 0x24
#define ENDEKENNUNG3  0x0d
#define START3        0x03
#define ENDE3         0x00


char c_str3[80];
unsigned char uc_zeichen3,uc_uartstatus3 = 0;


//*****************************************************************************
//	Protokoll - Zeichenauswertung der UART3
//  Input:	-
//	Output:	-
//*****************************************************************************
void receive_uart3(void)
{
unsigned char uc_x;

  uc_x = UART3_RX();

  watchdog_reset();
 
  if (uc_uartstatus3 == START3)
   {
     c_str3[uc_zeichen3] = uc_x;
	 uc_zeichen3++;
   }
  
  if (uc_x == STARTKENNUNG3)
   {
      uc_uartstatus3 = START3;
	  uc_zeichen3 = 0;
   }	  

  watchdog_reset();

  if ((uc_uartstatus3 == START3) && (uc_x == ENDEKENNUNG3)) 
   {
      uc_uartstatus3 = ENDE3;
	  if (uc_zeichen3 > 0) uc_zeichen3--;
	  c_str3[uc_zeichen3] = '\0';
	  Kommandointerpreter3(c_str3);
   }	    

  watchdog_reset();
}


//*****************************************************************************
//	Protokoll - String ueber UART0 an PC senden
//  Input:	-
//	Output:	-
//*****************************************************************************
void sende_UART3(char * pc_str)
{
char c_start[2] = {STARTKENNUNG3,0x00};
char c_ende[2]  = {ENDEKENNUNG3,0x00};

   watchdog_reset();
   strcpy(c_str3,c_start);
   strcat(c_str3,pc_str);
   watchdog_reset();
   strcat(c_str3,c_ende);
   watchdog_reset();

   UART3_TXStr(c_str3);
   strcpy(c_str3,""); 
   watchdog_reset();
}


